#include <SDL.h>
#include <cstdio>

void bucle(SDL_Renderer *renderer, int retardo);

int main( int argc, char * argv[] ) {
    SDL_Window *ventana;
    SDL_Renderer *renderer;

    SDL_Init(SDL_INIT_EVERYTHING);
    ventana = SDL_CreateWindow(NULL, SDL_WINDOWPOS_CENTERED, SDL_WINDOWPOS_CENTERED,
            640, 480, SDL_WINDOW_SHOWN | SDL_WINDOW_BORDERLESS);
    renderer = SDL_CreateRenderer(ventana, -1, 0);

    bucle(renderer, 60);
    bucle(renderer, 30);
    bucle(renderer, 10);
    bucle(renderer, 5);
    bucle(renderer, 0);

    SDL_DestroyRenderer(renderer);
    SDL_DestroyWindow(ventana);
    SDL_Quit();
    return 0;
}

void bucle(SDL_Renderer *renderer, int retardo) {
    Uint64 tick, tick0;
    SDL_Rect rect = {0,80,20,20};
    SDL_Rect rect2 = {0,160,20,20};
    SDL_Rect rect3 = {0,240,20,20};
    float velocidad = 80.0; // 80 pixels/s
    float velocidad2 = 120.0; // 120 pixels/s
    float velocidad3 = 160.0; // 160 pixels/s
    int frames=0;

    tick0 = SDL_GetTicks64();
    do {
        tick = SDL_GetTicks64()-tick0;
        rect.x = velocidad*(tick)/1000.0;
        rect2.x = velocidad2*(tick)/1000.0;
        rect3.x = velocidad3*(tick)/1000.0;
        SDL_SetRenderDrawColor(renderer, 0,0,0,255);
        SDL_RenderClear(renderer);
        SDL_SetRenderDrawColor(renderer, 255,255,255,255);
        SDL_RenderDrawRect(renderer, &rect);
        SDL_RenderDrawRect(renderer, &rect2);
        SDL_RenderDrawRect(renderer, &rect3);
        SDL_RenderPresent(renderer);
        frames++;
        SDL_Delay(retardo);
    } while(rect.x < 640);
    std::printf("Tiempo transcurrido: %.2f s\nfps: %.2f\n", tick/1000.0, frames*1000.0/tick);
}
